class org.cove.flade.primitives.Particle
{
   var init;
   var curr;
   var prev;
   var temp;
   var extents;
   var bmin;
   var bmax;
   var mtd;
   var isVisible;
   var wasCollision;
   var dmc;
   var lastIndex = 0;
   function Particle(posX, posY, rootmc)
   {
      this.init = new org.cove.flade.util.Vector(posX,posY);
      this.curr = new org.cove.flade.util.Vector(posX,posY);
      this.prev = new org.cove.flade.util.Vector(posX,posY);
      this.temp = new org.cove.flade.util.Vector(0,0);
      this.extents = new org.cove.flade.util.Vector(0,0);
      this.bmin = 0;
      this.bmax = 0;
      this.mtd = new org.cove.flade.util.Vector(0,0);
      this.initializeContainer(rootmc);
      this.isVisible = true;
      this.wasCollision = new Array(5);
   }
   function UpdateCount()
   {
      this.lastIndex = this.lastIndex + 1;
      if(this.lastIndex >= this.wasCollision.length)
      {
         this.lastIndex = 0;
      }
      this.wasCollision[this.lastIndex] = false;
   }
   function WasCollision()
   {
      var _loc2_ = 0;
      while(_loc2_ < this.wasCollision.length)
      {
         if(this.wasCollision[_loc2_])
         {
            return true;
         }
         _loc2_ = _loc2_ + 1;
      }
      return false;
   }
   function SetCollision()
   {
      this.wasCollision[this.lastIndex] = true;
   }
   function initializeContainer(rootmc)
   {
      if(_root.__debug__)
      {
         if(rootmc == null)
         {
            rootmc = _root;
         }
         var _loc4_ = rootmc.getNextHighestDepth();
         var _loc5_ = "_" + _loc4_;
         this.dmc = rootmc.createEmptyMovieClip(_loc5_,_loc4_);
      }
      else
      {
         this.dmc = _root;
      }
   }
   function setVisible(v)
   {
      this.isVisible = v;
   }
   function verlet(sysObj)
   {
      this.temp.x = this.curr.x;
      this.temp.y = this.curr.y;
      this.curr.x += sysObj.coeffDamp * (this.curr.x - this.prev.x) + sysObj.gravity.x;
      this.curr.y += sysObj.coeffDamp * (this.curr.y - this.prev.y) + sysObj.gravity.y;
      this.prev.x = this.temp.x;
      this.prev.y = this.temp.y;
   }
   function pin()
   {
      this.curr.x = this.init.x;
      this.curr.y = this.init.y;
      this.prev.x = this.init.x;
      this.prev.y = this.init.y;
   }
   function setPos(px, py)
   {
      this.curr.x = px;
      this.curr.y = py;
      this.prev.x = px;
      this.prev.y = py;
   }
   function getCardXProjection()
   {
      this.bmin = this.curr.x - this.extents.x;
      this.bmax = this.curr.x + this.extents.x;
   }
   function getCardYProjection()
   {
      this.bmin = this.curr.y - this.extents.y;
      this.bmax = this.curr.y + this.extents.y;
   }
   function getAxisProjection(axis)
   {
      var _loc5_ = new org.cove.flade.util.Vector(Math.abs(axis.x),Math.abs(axis.y));
      var _loc2_ = this.curr.dot(axis);
      var _loc3_ = this.extents.dot(_loc5_);
      this.bmin = _loc2_ - _loc3_;
      this.bmax = _loc2_ + _loc3_;
   }
   function setMTD(depthX, depthY, depthN, surfNormal)
   {
      var _loc4_ = Math.abs(depthX);
      var _loc3_ = Math.abs(depthY);
      var _loc2_ = Math.abs(depthN);
      if(_loc4_ < _loc3_ && _loc4_ < _loc2_)
      {
         this.mtd.setTo(depthX,0);
      }
      else if(_loc3_ < _loc4_ && _loc3_ < _loc2_)
      {
         this.mtd.setTo(0,depthY);
      }
      else if(_loc2_ < _loc4_ && _loc2_ < _loc3_)
      {
         this.mtd = surfNormal.multNew(depthN);
      }
   }
   function setXYMTD(depthX, depthY)
   {
      var _loc3_ = Math.abs(depthX);
      var _loc2_ = Math.abs(depthY);
      if(_loc3_ < _loc2_)
      {
         this.mtd.setTo(depthX,0);
      }
      else
      {
         this.mtd.setTo(0,depthY);
      }
   }
   function resolveCollision(normal, sysObj)
   {
      var _loc2_ = this.curr.minusNew(this.prev);
      var _loc3_ = normal.dot(_loc2_);
      var _loc8_ = _loc2_.minusNew(normal.multNew(_loc3_));
      var _loc4_ = _loc8_.multNew(sysObj.coeffFric);
      var _loc5_ = normal.multNew(_loc3_ * sysObj.coeffRest);
      var _loc6_ = _loc5_.plusNew(_loc4_);
      var _loc7_ = _loc2_.minusNew(_loc6_);
      this.curr.plus(this.mtd);
      this.prev = this.curr.minusNew(_loc7_);
   }
   function paint()
   {
   }
   function checkCollision(surface, sysObj)
   {
   }
}
