class org.cove.flade.surfaces.CircleTile extends org.cove.flade.surfaces.AbstractTile implements org.cove.flade.surfaces.Surface
{
   var radius;
   var isVisible;
   var dmc;
   var center;
   var normal;
   var minX;
   var maxX;
   var minY;
   var maxY;
   function CircleTile(cx, cy, r, rootmc)
   {
      super(cx,cy,rootmc);
      this.createBoundingRect(r * 2,r * 2);
      this.radius = r;
   }
   function paint()
   {
      if(this.isVisible)
      {
         this.dmc.clear();
         this.dmc.lineStyle(0,2237064,100);
         org.cove.flade.graphics.Graphics.paintCircle(this.dmc,this.center.x,this.center.y,this.radius);
      }
   }
   function resolveCircleCollision(p, sysObj)
   {
      if(this.isCircleColliding(p))
      {
         this.onContact();
         p.resolveCollision(this.normal,sysObj);
         p.SetCollision();
      }
   }
   function resolveRectangleCollision(p, sysObj)
   {
      if(this.isRectangleColliding(p))
      {
         this.onContact();
         p.resolveCollision(this.normal,sysObj);
      }
   }
   function isCircleColliding(p)
   {
      p.getCardXProjection();
      var _loc8_ = this.testIntervals(p.bmin,p.bmax,this.minX,this.maxX);
      if(_loc8_ == 0)
      {
         return false;
      }
      p.getCardYProjection();
      var _loc7_ = this.testIntervals(p.bmin,p.bmax,this.minY,this.maxY);
      if(_loc7_ == 0)
      {
         return false;
      }
      var _loc4_ = this.center.x - p.curr.x;
      var _loc3_ = this.center.y - p.curr.y;
      var _loc5_ = Math.sqrt(_loc4_ * _loc4_ + _loc3_ * _loc3_);
      var _loc6_ = p.radius + this.radius - _loc5_;
      if(_loc6_ > 0)
      {
         _loc4_ /= _loc5_;
         _loc3_ /= _loc5_;
         p.mtd.setTo((- _loc4_) * _loc6_,(- _loc3_) * _loc6_);
         this.normal.setTo(- _loc4_,- _loc3_);
         return true;
      }
      return false;
   }
   function isRectangleColliding(p)
   {
      p.getCardXProjection();
      var _loc6_ = this.testIntervals(p.bmin,p.bmax,this.minX,this.maxX);
      if(_loc6_ == 0)
      {
         return false;
      }
      p.getCardYProjection();
      var _loc5_ = this.testIntervals(p.bmin,p.bmax,this.minY,this.maxY);
      if(_loc5_ == 0)
      {
         return false;
      }
      var _loc11_ = Math.abs(_loc6_) < this.radius;
      var _loc12_ = Math.abs(_loc5_) < this.radius;
      if(_loc11_ && _loc12_)
      {
         var _loc10_ = p.curr.x + this.sign(this.center.x - p.curr.x) * (p.width / 2);
         var _loc9_ = p.curr.y + this.sign(this.center.y - p.curr.y) * (p.height / 2);
         p.vertex.setTo(_loc10_,_loc9_);
         var _loc4_ = p.vertex.x - this.center.x;
         var _loc3_ = p.vertex.y - this.center.y;
         var _loc8_ = Math.sqrt(_loc4_ * _loc4_ + _loc3_ * _loc3_);
         var _loc7_ = this.radius - _loc8_;
         if(_loc7_ > 0)
         {
            _loc4_ /= _loc8_;
            _loc3_ /= _loc8_;
            p.mtd.setTo(_loc4_ * _loc7_,_loc3_ * _loc7_);
            this.normal.setTo(_loc4_,_loc3_);
            return true;
         }
         return false;
      }
      p.setXYMTD(_loc6_,_loc5_);
      this.normal.setTo(p.mtd.x / Math.abs(_loc6_),p.mtd.y / Math.abs(_loc5_));
      return true;
   }
   function sign(val)
   {
      if(val < 0)
      {
         return -1;
      }
      if(val > 0)
      {
         return 1;
      }
   }
}
