class org.cove.flade.util.Vector
{
   var x;
   var y;
   function Vector(px, py)
   {
      this.x = px;
      this.y = py;
   }
   function setTo(px, py)
   {
      this.x = px;
      this.y = py;
   }
   function copy(v)
   {
      this.x = v.x;
      this.y = v.y;
   }
   function dot(v)
   {
      return this.x * v.x + this.y * v.y;
   }
   function cross(v)
   {
      return this.x * v.y - this.y * v.x;
   }
   function plus(v)
   {
      this.x += v.x;
      this.y += v.y;
      return this;
   }
   function plusNew(v)
   {
      return new org.cove.flade.util.Vector(this.x + v.x,this.y + v.y);
   }
   function minus(v)
   {
      this.x -= v.x;
      this.y -= v.y;
      return this;
   }
   function minusNew(v)
   {
      return new org.cove.flade.util.Vector(this.x - v.x,this.y - v.y);
   }
   function mult(s)
   {
      this.x *= s;
      this.y *= s;
      return this;
   }
   function multNew(s)
   {
      return new org.cove.flade.util.Vector(this.x * s,this.y * s);
   }
   function distance(v)
   {
      var _loc3_ = this.x - v.x;
      var _loc2_ = this.y - v.y;
      return Math.sqrt(_loc3_ * _loc3_ + _loc2_ * _loc2_);
   }
   function normalize()
   {
      var _loc2_ = Math.sqrt(this.x * this.x + this.y * this.y);
      this.x /= _loc2_;
      this.y /= _loc2_;
      return this;
   }
   function magnitude()
   {
      return Math.sqrt(this.x * this.x + this.y * this.y);
   }
   function project(b)
   {
      var _loc5_ = this.dot(b);
      var _loc4_ = b.x * b.x + b.y * b.y;
      var _loc3_ = new org.cove.flade.util.Vector(0,0);
      _loc3_.x = _loc5_ / _loc4_ * b.x;
      _loc3_.y = _loc5_ / _loc4_ * b.y;
      return _loc3_;
   }
}
